\documentclass{scrartcl}
\usepackage[top=1in, bottom=1.25in, left=1.25in, right=1.25in]{geometry}
\usepackage{array}
\usepackage[utf8x]{inputenc}
\usepackage[ngerman]{babel}
\usepackage{algorithm2e}
\usepackage{amsmath}
\usepackage{amssymb}
\usepackage{lmodern}
\usepackage{stmaryrd}
%\usepackage{kpfonts}
\usepackage{tikz}
\usepackage{mathtools}
\DeclarePairedDelimiter{\ceil}{\lceil}{\rceil}	%Runden
\usetikzlibrary{trees}	%Bäume
\usetikzlibrary{positioning,calc,shapes,chains,arrows}

\setlength{\parindent}{0em}
\newcommand{\vcenteredinclude}[1]{\begingroup
\setbox0=\hbox{#1}%
\parbox{\wd0}{\box0}\endgroup}
\newcolumntype{P}[1]{>{\raggedright\arraybackslash}p{#1}}

\tikzset{
itria/.style={
  draw,dashed,shape border uses incircle,
  isosceles triangle,shape border rotate=90,yshift=-1.5cm}}

\pagenumbering{gobble}
\def\kuller{\bigcirc}

\pagestyle{plain}

\begin{document}
\begin{center}$ $
{\fontsize{24}{10} \selectfont
\textbf{Technical Neural Nets}$ $\\
$ $\\
\underline{Sheet 6}
}\\
\vspace{2em}
\begin{minipage}[t]{0.49\textwidth}
{\fontsize{15}{20} \raggedright \selectfont
Group \textbf{E}\\
Friday 10-12h\\
Livin Natious\\
}
\end{minipage}
\begin{minipage}[t]{0.49\textwidth}
{\fontsize{15}{20} \raggedleft \selectfont 
Tobias Kremeyer\\
}\end{minipage}
\end{center}
%\vspace{1em}
%{\fontsize{15}{20} \selectfont \setlength\extrarowheight{10pt}
%\begin{tabular}{|c||c|c||c|c||c|c||c|c||c|c|}
%\hline
%\textbf{Punkte:} & A1 & \hspace{1.7em} & A2 & \hspace{1.7em} & A3 & \hspace{1.7em} & A4 & \hspace{1.7em} & $\Sigma$ & \hspace{2.4em} \\
%\hline
%\end{tabular}}

\vspace{1em}

\section*{Assignment 32) RBF Networks}

Let the input space of an RBF net be $N$-dimensional. Let $X$ be the input vector and $C_k$ the center vector of RBF neuron $k$.

The RBF network approach can be modified to a characteristic that has different extensions in the different axes of the input space (thus an elliptical characteristic).\\
This can be achieved by applying an adapted distance function instead of the original distance function 
$$ d_k(X,C_k) = || X - C_k ||_2 = \sqrt{\sum\limits_{i = 1}^{N} (X_i - {C_k}_i)^2}$$

Let $D^k$ be a vector of the dilatations for each dimension for neuron $k$.

Then, apply the distance function
$$ d_k'(X,C_k) = \sqrt{\sum\limits_{i = 1}^{N} (\frac{1}{D^k_i} \cdot (X_i - {C_k}_i))^2}$$

With this distance function, the ellipse has still the center $C_k$, but for dimension $i$ the gaussian bell is dilated by $D^k_i$.

\section*{Assignment 33) SOM Learning}

\textbf{Major steps:}
\begin{enumerate}\addtocounter{enumi}{-1}
\item \textbf{Initialize SOM.}
Desribe the task; define training data $^pX$, labeling data, the grid structure, the network size, the learning parameters; initialize the center vectors $C_k$.\\
\underline{Learning parameters:}\\
\begin{itemize}
\item Learning rate function $\eta(t): 0 < \eta(t) < 1$
\item Distance function $dist(i,j)$ for neurons on the grid. Examples: Euclidean distance, Manhattan distance
\item Neighbourhood function $h(dist, t)$
\item Similarity measure $s(C_k, ^pX)$ in the input space. Example: Euclidean distance
\end{itemize}
\item \textbf{Choose a stimulus, apply it to the SOM.} Choose one of the training examples. (In case of fixed set: Same probability for all examples, changing order)
\item \textbf{Calculate the response.} Compare the applied pattern $^pX$ to the center $C_k$ of each SOM neuron $k$ by using the similarity measure $s$.
\item \textbf{Determine the winner.} The neuron $i$ with the best response is the winner.
\item \textbf{Learning rule, calculate $\Delta C_k$.} Pull the winner neuron and neighboured neurons towards the input example by using the learning rule:
$$\Delta C_j = \eta(t) \cdot h(dist(i,j),t) \cdot (^pX, C_j)$$ for all neurons $j$.
\item \textbf{Update step.} Apply the updates: $C_k^{new} = C_k^{old} + \Delta C_k$.
\item \textbf{Continue learning? Goto 1.} Check if a stopping condition (as performance, convergence, time or boredness of the user) is reached.
\item \textbf{Label SOM neurons.} Interpret the results and assign meanings to the different neurons.
\end{enumerate}

\section*{Assignment 34) Exponential Decay of $\eta$}

Exponential Decay in general: $\eta(t) = (\eta_{\text{init}}-\eta_{\text{final}}) \cdot e^{-\lambda t} + \eta_{\text{final}}$

Assuming we consider $\eta(t_{1/32}) = \frac{1}{32}(\eta_{\text{init}}-\eta_{\text{final}}) + \eta_{\text{final}}$ as converged, it applies (formula for half-time):

\begin{eqnarray*}
&t_{max} = t_{1/32} &= log_2(32) \cdot \frac{ln(2)}{\lambda}\\
\Leftrightarrow& \lambda &= log_2(32) \cdot \frac{ln(2)}{t_{max}}\\
\Leftrightarrow& \lambda &= \frac{5 \cdot ln(2)}{t_{max}}\\
\end{eqnarray*}

So the decay function is 
$$\eta(t) = (\eta_{\text{init}}-\eta_{\text{final}}) \cdot e^{-5ln(2)t_{max}^{-1} t} + \eta_{\text{final}}$$

\includegraphics[scale=0.5]{34.png}

\section*{Assignment 36) }

SOM Neuron $i$ is the winner neuron for stimulus $^pX$\\
\begin{equation}\label{36-1}
\forall k \leq K, k \neq i: || C_k - ^pX || \geq || C_i - ^pX ||
\end{equation}

Let $C'_k$ be the new center vectors after applying the learning rule:
\begin{equation}\label{36-2}
\forall k \leq K: C'_k = C_k + \eta(t) \cdot h(dist(i,k),t) \cdot (^pX-C_k)
\end{equation}

When the same stimulus $^pX$ is presented to the network directly again, the winner shall
be again neuron $i$. This means:
\begin{equation}\label{36-3}
\forall k \leq K, k \neq i: || C'_k - ^pX || \geq || C'_i - ^pX || 
\end{equation}

With~\ref{36-1}, \ref{36-2} and \ref{36-3}:

\begin{eqnarray*}
\forall k \leq K, k \neq i: &|| C'_k - ^pX || \geq || C'_i - ^pX || \\
\Leftrightarrow \forall k \leq K, k \neq i: &|| C_k + \eta(t) \cdot h(dist(i,k),t) \cdot (^pX-C_k) - ^pX || \\
&\geq || C_i + \eta(t) \cdot h(dist(i,i),t) \cdot (^pX-C_i) - ^pX || 
\end{eqnarray*}

Conditions to apply so $i$ becomes the winner again:
\begin{itemize}
\item $\forall k,l \leq K: dist(k,l) \geq 0$. Distances non-negative.
\item $\forall k \leq K: dist(i,i) \leq dist(i,k)$. Neuron $i$ is nearer to itself than any other neuron.
\item $\forall t\forall q \leq dist(i,i): h(dist(i,i),t) \geq h(q,t)$. No neuron gets pulled more towards $^pX$ than neuron $i$.
\item $\forall t: 0.0 \leq \eta(t) \leq 1.0$. Don't push the neuron away from $^pX$, don't overshoot the target
\end{itemize}

\section*{Assignment 37) Classification vs Clustering}
\paragraph{Classification}
In classification problems, the target is to be able to classify new samples into already known classes. For the training datasets the corresponding classes have to be given. This is a supervised learning process.
\paragraph{Clustering}
In clustering problems, the target is to find clusters in unlabeled data. This is an unsupervised learning process.

\subsection*{Example}
When I go into a bar, looking for girls, I usually solve a \textbf{classification} problem: I already know the classes beforehand (Hot, Not Hot) and my aim is to classify the present girls into those classes.\\
On the other hand, I as a computer scientist have very little knowledge about girls. To build up some knowledge, I may find that specific character traits usually will go together. Those sets of traits can be called \textbf{clusters}, and since I don't preset them, it's a \textbf{clustering} process.


\end{document}